

/*
 *
 *    OPEN-XCHANGE legal information
 *
 *    All intellectual property rights in the Software are protected by
 *    international copyright laws.
 *
 *
 *    In some countries OX, OX Open-Xchange, open xchange and OXtender
 *    as well as the corresponding Logos OX Open-Xchange and OX are registered
 *    trademarks.
 *    The use of the Logos is not covered by the GNU General Public License.
 *    Instead, you are allowed to use these Logos according to the terms and
 *    conditions of the Creative Commons License, Version 2.5, Attribution,
 *    Non-commercial, ShareAlike, and the interpretation of the term
 *    Non-commercial applicable to the aforementioned license is published
 *    on the web site http://www.open-xchange.com/EN/legal/index.html.
 *
 *    Please make sure that third-party modules and libraries are used
 *    according to their respective licenses.
 *
 *    Any modifications to this package must retain all copyright notices
 *    of the original copyright holder(s) for the original code used.
 *
 *    After any such modifications, the original and derivative code shall remain
 *    under the copyright of the copyright holder(s) and/or original author(s)per
 *    the Attribution and Assignment Agreement that can be located at
 *    http://www.open-xchange.com/EN/developer/. The contributing author shall be
 *    given Attribution for the derivative code and a license granting use.
 *
 *     Copyright (C) 2016 OX Software GmbH
 *     Mail: info@open-xchange.com
 *
 *
 *     This program is free software; you can redistribute it and/or modify it
 *     under the terms of the GNU General Public License, Version 2 as published
 *     by the Free Software Foundation.
 *
 *     This program is distributed in the hope that it will be useful, but
 *     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 *     for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc., 59
 *     Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

package org.docx4j.dml.chartex2014;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlType;


/**
 * <p>Java class for CT_SeriesLayoutProperties complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="CT_SeriesLayoutProperties">
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element name="parentLabelLayout" type="{http://schemas.microsoft.com/office/drawing/2014/chartex}CT_ParentLabelLayout" minOccurs="0"/>
 *         &lt;element name="regionLabelLayout" type="{http://schemas.microsoft.com/office/drawing/2014/chartex}CT_RegionLabelLayout" minOccurs="0"/>
 *         &lt;element name="visibility" type="{http://schemas.microsoft.com/office/drawing/2014/chartex}CT_SeriesElementVisibilities" minOccurs="0"/>
 *         &lt;choice minOccurs="0">
 *           &lt;element name="aggregation" type="{http://schemas.microsoft.com/office/drawing/2014/chartex}CT_Aggregation" minOccurs="0"/>
 *           &lt;element name="binning" type="{http://schemas.microsoft.com/office/drawing/2014/chartex}CT_Binning" minOccurs="0"/>
 *         &lt;/choice>
 *         &lt;element name="geography" type="{http://schemas.microsoft.com/office/drawing/2014/chartex}CT_Geography" minOccurs="0"/>
 *         &lt;element name="statistics" type="{http://schemas.microsoft.com/office/drawing/2014/chartex}CT_Statistics" minOccurs="0"/>
 *         &lt;element name="subtotals" type="{http://schemas.microsoft.com/office/drawing/2014/chartex}CT_Subtotals" minOccurs="0"/>
 *         &lt;element name="extLst" type="{http://schemas.microsoft.com/office/drawing/2014/chartex}CT_ExtensionList" minOccurs="0"/>
 *       &lt;/sequence>
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "CT_SeriesLayoutProperties", propOrder = {
    "parentLabelLayout",
    "regionLabelLayout",
    "visibility",
    "aggregation",
    "binning",
    "geography",
    "statistics",
    "subtotals",
    "extLst"
})
public class CTSeriesLayoutProperties {

    protected CTParentLabelLayout parentLabelLayout;
    protected CTRegionLabelLayout regionLabelLayout;
    protected CTSeriesElementVisibilities visibility;
    protected CTAggregation aggregation;
    protected CTBinning binning;
    protected CTGeography geography;
    protected CTStatistics statistics;
    protected CTSubtotals subtotals;
    protected CTExtensionList extLst;

    /**
     * Gets the value of the parentLabelLayout property.
     * 
     * @return
     *     possible object is
     *     {@link CTParentLabelLayout }
     *     
     */
    public CTParentLabelLayout getParentLabelLayout() {
        return parentLabelLayout;
    }

    /**
     * Sets the value of the parentLabelLayout property.
     * 
     * @param value
     *     allowed object is
     *     {@link CTParentLabelLayout }
     *     
     */
    public void setParentLabelLayout(CTParentLabelLayout value) {
        this.parentLabelLayout = value;
    }

    /**
     * Gets the value of the regionLabelLayout property.
     * 
     * @return
     *     possible object is
     *     {@link CTRegionLabelLayout }
     *     
     */
    public CTRegionLabelLayout getRegionLabelLayout() {
        return regionLabelLayout;
    }

    /**
     * Sets the value of the regionLabelLayout property.
     * 
     * @param value
     *     allowed object is
     *     {@link CTRegionLabelLayout }
     *     
     */
    public void setRegionLabelLayout(CTRegionLabelLayout value) {
        this.regionLabelLayout = value;
    }

    /**
     * Gets the value of the visibility property.
     * 
     * @return
     *     possible object is
     *     {@link CTSeriesElementVisibilities }
     *     
     */
    public CTSeriesElementVisibilities getVisibility() {
        return visibility;
    }

    /**
     * Sets the value of the visibility property.
     * 
     * @param value
     *     allowed object is
     *     {@link CTSeriesElementVisibilities }
     *     
     */
    public void setVisibility(CTSeriesElementVisibilities value) {
        this.visibility = value;
    }

    /**
     * Gets the value of the aggregation property.
     * 
     * @return
     *     possible object is
     *     {@link CTAggregation }
     *     
     */
    public CTAggregation getAggregation() {
        return aggregation;
    }

    /**
     * Sets the value of the aggregation property.
     * 
     * @param value
     *     allowed object is
     *     {@link CTAggregation }
     *     
     */
    public void setAggregation(CTAggregation value) {
        this.aggregation = value;
    }

    /**
     * Gets the value of the binning property.
     * 
     * @return
     *     possible object is
     *     {@link CTBinning }
     *     
     */
    public CTBinning getBinning() {
        return binning;
    }

    /**
     * Sets the value of the binning property.
     * 
     * @param value
     *     allowed object is
     *     {@link CTBinning }
     *     
     */
    public void setBinning(CTBinning value) {
        this.binning = value;
    }

    /**
     * Gets the value of the geography property.
     * 
     * @return
     *     possible object is
     *     {@link CTGeography }
     *     
     */
    public CTGeography getGeography() {
        return geography;
    }

    /**
     * Sets the value of the geography property.
     * 
     * @param value
     *     allowed object is
     *     {@link CTGeography }
     *     
     */
    public void setGeography(CTGeography value) {
        this.geography = value;
    }

    /**
     * Gets the value of the statistics property.
     * 
     * @return
     *     possible object is
     *     {@link CTStatistics }
     *     
     */
    public CTStatistics getStatistics() {
        return statistics;
    }

    /**
     * Sets the value of the statistics property.
     * 
     * @param value
     *     allowed object is
     *     {@link CTStatistics }
     *     
     */
    public void setStatistics(CTStatistics value) {
        this.statistics = value;
    }

    /**
     * Gets the value of the subtotals property.
     * 
     * @return
     *     possible object is
     *     {@link CTSubtotals }
     *     
     */
    public CTSubtotals getSubtotals() {
        return subtotals;
    }

    /**
     * Sets the value of the subtotals property.
     * 
     * @param value
     *     allowed object is
     *     {@link CTSubtotals }
     *     
     */
    public void setSubtotals(CTSubtotals value) {
        this.subtotals = value;
    }

    /**
     * Gets the value of the extLst property.
     * 
     * @return
     *     possible object is
     *     {@link CTExtensionList }
     *     
     */
    public CTExtensionList getExtLst() {
        return extLst;
    }

    /**
     * Sets the value of the extLst property.
     * 
     * @param value
     *     allowed object is
     *     {@link CTExtensionList }
     *     
     */
    public void setExtLst(CTExtensionList value) {
        this.extLst = value;
    }

}
